#!/usr/bin/env pypy

###############################################################################
# Mjöllnir -- a simulator of the magnetic properties of polynuclear complexes
# Copyright (c) 2009--2020 Anton S. Lytvynenko, Elena A. Mikhalyova
#
# The authors thanks to Dr. V. A. Bogaenko and to Sergei Litvinenko for
# technical help and valuable discussion.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

import sys,os

def print_elem(x):
    if x=="":
        return "0"
    else:
        return x

m_number = int(sys.argv[1])
m_dir = sys.argv[2]
if m_dir!='z' and m_dir!='x':
    raise Exception("Wrong direction")

fname1 = "m"+str(m_number)+"_"+m_dir+"_matrices_list"
fname2 = "m"+str(m_number)+"_"+m_dir+"_coefs"
foutname = "m"+str(m_number)+"_"+m_dir+"_symbolic_mtx"

fin = open(fname1,"r")

num_files, eigenproblem_dim = fin.readline().split()

joined_matrix = [["" for i in range(int(eigenproblem_dim))] for j in range(int(eigenproblem_dim))]

coefs = open(fname2).readline().split(",")

for mtxfile in fin.readlines():
    f = open(mtxfile.strip(),"r")
    nel = f.readline()
    coef = coefs.pop(0)
    for l in f.readlines():
        i,j,val = l.split()
        if joined_matrix[int(i)-1][int(j)-1]=="":
            joined_matrix[int(i)-1][int(j)-1]=str(val)+"*"+coef
        else:
            joined_matrix[int(i)-1][int(j)-1]+="+("+str(val)+")*"+coef

fout = open(foutname,'w')
fout.write(os.linesep.join([" ".join(map(print_elem,joined_matrix[i])) for i in range(int(eigenproblem_dim))]))
fout.close()


