#!/usr/bin/env pypy

###############################################################################
# Mjöllnir -- a simulator of the magnetic properties of polynuclear complexes
# Copyright (c) 2009--2020 Anton S. Lytvynenko, Elena A. Mikhalyova
#
# The authors thanks to Dr. V. A. Bogaenko and to Sergei Litvinenko for
# technical help and valuable discussion.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

import os,sys
from Tkinter import *
import Tkinter, Tkconstants, tkFileDialog

def check_working_dir(dname):
    return os.access(os.path.join(dname,"fragments"), os.R_OK) # Currently a valid directory must contain at least 'fragments' file

def check_parsed_dir(dname):
    return True

def select_dir():
    global current_dir, wmj_directorystatus
    current_dir = tkFileDialog.askdirectory()
    os.chdir(current_dir)
    if not check_working_dir(current_dir):
        wmj_directorystatus.config(text="The selected directory is probably not a valid Mjollnir working directory!")
    else:
        wmj_directorystatus.config(text="You are working in the %s directory" % current_dir)

mjollnir_dir = os.path.dirname(os.path.realpath(__file__)) # We expect that other Mjollnir files will be located at the same directory as this script
current_dir = os.getcwd()

root = Tk()
root.title("Mjollnir launcher")

wmj_dirselector = Button(text="Select working directory", command = select_dir)
wmj_directorystatus = Label(text="Current working directory %s selected automatically" % current_dir) # Label with information if the chosen dir is eligible
wmj_parser_launcher = Button(text="Launch parsing of the model")
wmj_fit_launcher = Button(text="Launch fitting of the model")

wmj_dirselector.pack()
wmj_parser_launcher.pack()
wmj_fit_launcher.pack()
wmj_directorystatus.pack()

root.mainloop()
